/*
    libresize 0.08
    Copyright (C) 1998-1999  Andrew Clausen  <clausen@alphalink.com.au>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    I can also be contacted at:

    Andrew Clausen
    18 Shaw St
    Ashwood, 3147
    Victoria, Australia
*/

#ifndef TRAVERSE_H_INCLUDED
#define TRAVERSE_H_INCLUDED

#include "fatio.h"

typedef struct _trimlib_traverse_info   trimlib_traverse_info;

struct _trimlib_traverse_info {
    msdos_filesystem   *fs;
    char                dir_name[256];
    cluster_t           start_cluster;
    cluster_t           this_cluster;
    directory_entry    *dir_entries;
    directory_entry    *this_dir_entry;
    int                 this_dir_entry_index;
    int                 is_legacy_root_dir;
};

cluster_t
trimlib_file_get_first_cluster (msdos_filesystem *fs,
                                directory_entry *dir_entry);

void
trimlib_file_set_first_cluster (msdos_filesystem *fs,
                                directory_entry *dir_entry, cluster_t cluster);

int
trimlib_has_first_cluster (msdos_filesystem *fs, directory_entry *dir_entry);

int
entries_per_buffer (trimlib_traverse_info *traverse_info);

// starts traversal at an arbitary cluster.  if start_cluster==0, then uses
// root directory
trimlib_traverse_info *
trimlib_traversal_begin (msdos_filesystem *fs, int start_cluster,
                         char *dir_name);

// frees traverse_info
void
trimlib_traversal_complete (trimlib_traverse_info *traverse_info);

// begins traversal, starting at parent->first_cluster
trimlib_traverse_info *
trimlib_traverse_directory (trimlib_traverse_info *traverse_info,
                            directory_entry *parent);

// returns the next directory entry
directory_entry *
trimlib_get_next (trimlib_traverse_info *traversal_info);

int
trimlib_is_file (directory_entry *dir_entry);

int
trimlib_is_directory (directory_entry *dir_entry);

void
trimlib_file_get_name (directory_entry *dir_entry, char *result);

#endif /* TRAVERSE_H_INCLUDED */
